/*******************************************
*         Define the database context      *
********************************************/

USE [DBEasy_CHUJacques];


/********************************************
** Change Database option AUTO_CLOSE to OFF *
********************************************/

ALTER DATABASE [DBEasy_CHUJacques] SET AUTO_CLOSE OFF;
IF @@ERROR = 0 print 'The database option AUTO_CLOSE has been set to OFF'
ELSE print 'Error while setting database option AUTO_CLOSE to OFF';

/*********************************************************************************************************************
* Liste des indexes de la base  vider depuis la V4 sur les 3 tables qui seront modifis par la migration vers la V8 *
**********************************************************************************************************************/

DECLARE @IndexesToRemove as nvarchar(4000)
DECLARE @TableName as varchar(255)
DECLARE @IndexName as varchar(255)
DECLARE @IsTheFirst as bit
SELECT @IsTheFirst = 0, @IndexesToRemove = ''

DECLARE IndexCursor CURSOR FOR
SELECT Tab.name, Idx.name
FROM sys.tables Tab Inner join sys.indexes  Idx ON Tab.object_id    = Idx.object_id 
WHERE Tab.type_desc = 'USER_TABLE' AND Idx.is_primary_key = 0 AND Tab.name IN ('JRNL','Line','WValue') 
ORDER BY Tab.name, Idx.name

OPEN IndexCursor
FETCH NEXT FROM IndexCursor INTO @TableName, @IndexName
WHILE @@FETCH_STATUS = 0
BEGIN
  IF @IsTheFirst=1 SET @IndexesToRemove = @IndexesToRemove +', ' 
  SET @IndexesToRemove = @IndexesToRemove + @IndexName + ' ON ' + @TableName
  IF @IsTheFirst=0 SET @IsTheFirst=1
  FETCH NEXT FROM IndexCursor INTO @TableName, @IndexName
END
CLOSE IndexCursor
DEALLOCATE IndexCursor

if LEN(@IndexesToRemove) > 0 BEGIN 
  SET @IndexesToRemove = N'DROP INDEX ' + @IndexesToRemove
  print 'Launching query : '+@IndexesToRemove  
  EXEC  sp_executesql @IndexesToRemove;
  IF @@ERROR = 0 print 'Index removed on JRNL, Line and WValue, except primary keys'
  ELSE print 'Error while removing index from JRNl, Line and WValue';
END;
ELSE print 'No index found';


/***************
* Desactivate  *
***************/

DISABLE TRIGGER ALL ON DATABASE;
IF @@ERROR = 0 print 'All triggers disabled on Database '+DB_NAME()
ELSE print 'Error while disabling all triggers on database';